#include <machine.h>
#include "iodefine.h"
#include "ff.h"
#include "diskio.h"
#include "spi.h"


/*  p SCI0SPIʐMɎgƂ SH2-7144 szu
MMC_DI SCI0TXD(PA1) CN4-18
MMC_DO SCI0RXD(PA0) CN4-17
MMC_CK SCI0SCK(PA2) CN4-19
MMC_CS   CS   (PE3) CN1- 4
*/


/*ŏ100kbps`400kbpsǂƂĂ̂*/
/*#define SLOW_BRR 199   /*=25MHz31.25kbps */
/*#define SLOW_BRR  99   /*=25MHz 62.5kbps */
#define SLOW_BRR  49   /*=25MHz  125kbps */
#define FAST_BRR   0   /*=25MHz 6250kbps */

#define SCIforSPI SCI0

#define PORTCONFforMMC PFC.PEIORL.BIT.B3
#define CONF_OUTPUT 1

#define MMC_CS PE.DRL.BIT.B3

/* H8n[hEFA       */
/* mode 0 ᑬ[h  */
/* mode 1 [h  */

void initSPI(int mode)
{
	int i,dummy,brr;
	
	MST.CR1.BIT._SCI0 = 0; /*reset SCI module standby*/
	PFC.PACRL2.BIT.PA0MD = 1;/* PA0MD 0:PA0, 1:RXD0 */
	PFC.PACRL2.BIT.PA1MD = 1;/* PA1MD 0:PA1, 1:TXD0 */
	PFC.PACRL2.BIT.PA2MD = 1;/* PA2MD 0:PA2, 1:SCK0, 2:DREQ0 3:IRQ0*/
	PFC.PAIORL.BIT.B1    = 1;/* PA-1(SCI0TXD): set the pin output*/
	PFC.PAIORL.BIT.B2    = 1;/* PA-2(SCI0SCK): output*/
	PA.DR.BIT.B1         = 1;/* PA-1 output=1*/

	brr = mode? FAST_BRR : SLOW_BRR;
	SCIforSPI.SDCR.BIT.DIR = 1;   /* MSB t@[XgőM */
	SCIforSPI.SCR.BYTE = 0x00;    /* SCK[q͓Clocko */
	SCIforSPI.SSR.BYTE = 0x80;    /* G[tONA 10000000 */
	SCIforSPI.SMR.BYTE = 0x80;    /* Clock[hC=25MHz */
	SCIforSPI.BRR = brr;          /*@baud rate̐ݒ@*/
	for (i=0; i<(brr+1)*40; i++); /* 1bit(160ns)ȏ҂ */
	/*INTC.IPRB.BIT._SCI0=1;                  /*SCI0̊荞݂Dɂ*/
	
}

void initSPI_CS(void)
{
	PORTCONFforMMC = CONF_OUTPUT;
	MMC_CS = 1;
}

/*DMA0RXDpɁCDMA1TXDɎg*/
void initDMAC(void)
{
	MST.CR1.BIT._DTC = 0;         /*reset DTC,DMAC module standby*/
	/*INTC.IPRC.BIT._DMAC0=0xf;     /*DMAC0̊荞݂Dɂ*/
	INTC.IPRC.BIT._DMAC1=0xf;     /*DMAC1̊荞݂Dɂ*/
	DMAC.DMAOR.BIT.DME = 1;        /*DMAC }X^Cl[u*/
}

/*1byte̒lbittɂ ̂Ƃsv*/
/*static unsigned char reverseBit8(unsigned char x)
{
	x=(x<<4)|(x>>4);
	x=((x&0x33)<<2)|((x&0xcc)>>2);
	x=((x&0x55)<<1)|((x&0xaa)>>1);
	return x;
}*/

#ifdef _SPI_POLLING   /************************************/
/* SPI (SCI) datanum bytes o*/
/*߂lFMoCg*/
/*int SPI_putDataPolling(unsigned char *data, int num)*/
int SPI_putData(unsigned char *data, int num)
{
	int i;
	SCIforSPI.SCR.BIT.TE=1;       /*M*/
	for (i=0; i<num; i++,data++) {
		while (!SCIforSPI.SSR.BIT.TDRE); /*TDRE==0Ȃ҂*/
		SCIforSPI.TDR = *data;
		SCIforSPI.SSR.BIT.TDRE = 0; /*clear flag*/
	}
	while(!SCIforSPI.SSR.BIT.TEND);
	SCIforSPI.SCR.BIT.TE=0;       /*M֎~*/
	return i;
}

/* SPI (SCI) datanum bytes */
/*߂lFMoCg*/
/*int SPI_getDataPolling(unsigned char *data, int num)*/
int SPI_getData(unsigned char *data, int num)
{
	int i;
	SCIforSPI.SCR.BIT.TE=1;       /*M*/
	while (!SCIforSPI.SSR.BIT.TDRE); /*TDRE==0Ȃ҂*/
	SCIforSPI.SCR.BIT.TE=0;       /*M֎~*/
	for (i=0; i<num; i++,data++) {
		if (SCIforSPI.SSR.BIT.ORER) SCIforSPI.SSR.BIT.ORER=0;
		SCIforSPI.SSR.BIT.RDRF=0;
		SCIforSPI.SCR.BYTE=0x30;       /*M TE,RE𓯎1ɂȂ΂ȂȂ*/
		SCIforSPI.TDR = 0xff;
		SCIforSPI.SSR.BIT.TDRE = 0; /*clear flag*/
		while (!SCIforSPI.SSR.BIT.RDRF);
		SCIforSPI.SCR.BYTE=0;         /*M֎~*/
		SCIforSPI.SSR.BIT.RDRF=0;
		*data=SCIforSPI.RDR;
	}
	return i;
}
#endif /*#ifdef _SPI_POLLING ***************************/


#ifdef _SPI_DMA   /************************************/
/* SPI (SCI) DMApdatanum bytes o*/
/*int SPI_putDataDMA(unsigned char *data, int num)*/
int SPI_putData(unsigned char *data, int num)
{
	int i;

	DMAC1.SAR = data;                 /* M */
	DMAC1.DAR = &(SCIforSPI.TDR);     /* M */
	DMAC1.DMATCR = num;               /* ] */
	/*DMAC1.CHCR.BIT.DM = 0;          /* fXeBl[VAhX͌Œ */
	/*DMAC1.CHCR.BIT.SM = 1;          /* \[XAhX͑@8 rbg]+1 */
	/*DMAC1.CHCR.BIT.RS = 0xc;        /* N\[X SCI0 iTXI_0j*/
	/*DMAC1.CHCR.BIT.TM = 0;          /* TCNX`[[hj*/
	/*DMAC1.CHCR.BIT.TS = 0;          /* gX~bgTCY  oCgTCYi8 rbgj*/
	/*DMAC1.CHCR.BIT.IE = 1;          /* C^[vgCl[u */
	/*DMAC1.CHCR.BIT.DE = 1;          /* DMAC Cl[u */
	/* 0000 0000 0000 0000 0001 1100 0000 0101 =>> 0x00001c05*/
	DMAC1.CHCR.LONG = 0x1c05;
	if (DMAC1.CHCR.BIT.TE) DMAC1.CHCR.BIT.TE=0;
	
	SCIforSPI.SCR.BYTE = 0xa0;    /* M SCIM荞݋ SCK[q͓Clocko */
	
	while (!DMAC1.CHCR.BIT.TE);                /* DMAC1.CHCR.BIT.TE1ɂȂ]I */

	while(!SCIforSPI.SSR.BIT.TEND);
	/*KvȃNbNoĂ~܂悤ɂ*/
	SCIforSPI.SCR.BYTE = 0x00;    /* M֎~ SCIM荞݋֎~ SCK[q͓Clocko */

	return num;
}

/* SPI (SCI) datanum bytes */
/*߂lFMoCg*/
/*int SPI_getDataDMA(unsigned char *data, int num)*/
int SPI_getData(unsigned char *data, int num)
{
	int i;
	const char dummy=0xff;

	DMAC1.SAR = &dummy;               /* M */
	DMAC1.DAR = &(SCIforSPI.TDR);     /* M */
	DMAC1.DMATCR = num;               /* ] */
	/*DMAC1.CHCR.BIT.DM = 0;          /* fXeBl[VAhX͌Œ */
	/*DMAC1.CHCR.BIT.SM = 0;          /* \[XAhX͌Œ */
	/*DMAC1.CHCR.BIT.RS = 0xc;        /* N\[X SCI0 iTXI_0j*/
	/*DMAC1.CHCR.BIT.TM = 0;          /* TCNX`[[hj*/
	/*DMAC1.CHCR.BIT.TS = 0;          /* gX~bgTCY  oCgTCYi8 rbgj*/
	/*DMAC1.CHCR.BIT.IE = 1;          /* C^[vgCl[u */
	/*DMAC1.CHCR.BIT.DE = 1;          /* DMAC Cl[u */
	/* 0000 0000 0000 0000 0000 1100 0000 0101 =>> 0x00000c05*/
	DMAC1.CHCR.LONG = 0xc05;
	if (DMAC1.CHCR.BIT.TE) DMAC1.CHCR.BIT.TE=0;

	DMAC0.SAR = &(SCIforSPI.RDR);     /* M */
	DMAC0.DAR = data;                 /* M */
	DMAC0.DMATCR = num;               /* ] */
	/*DMAC0.CHCR.BIT.DM = 1;          /* fXeBl[VAhX͑@8 rbg]+1 */
	/*DMAC0.CHCR.BIT.SM = 0;          /* \[XAhX͌Œ */
	/*DMAC0.CHCR.BIT.RS = 0xd;        /* N\[X SCI0 iRXI_0j*/
	/*DMAC0.CHCR.BIT.TM = 0;          /* TCNX`[[hj*/
	/*DMAC0.CHCR.BIT.TS = 0;          /* gX~bgTCY  oCgTCYi8 rbgj*/
	/*DMAC0.CHCR.BIT.IE = 0;          /* C^[vgCl[u */
	/*DMAC0.CHCR.BIT.DE = 1;          /* DMAC Cl[u */
	/* 0000 0000 0000 0000 0100 1101 0000 0001 =>> 0x00004d01*/
	DMAC0.CHCR.LONG = 0x4d01;
	if (DMAC0.CHCR.BIT.TE) DMAC0.CHCR.BIT.TE=0;

	SCIforSPI.SSR.BYTE &= 0x87;                 /* ORER FER PE RDRF ̃NA*/
	SCIforSPI.SCR.BYTE = 0xf0;    /* M SCIM荞݋ SCK[q͓Clocko */

	while (!DMAC1.CHCR.BIT.TE);                /* DMAC1.CHCR.BIT.TE1ɂȂ]I */

	while(!SCIforSPI.SSR.BIT.TEND);
	/*KvȃNbNoĂ~܂悤ɂ*/
	SCIforSPI.SCR.BYTE = 0x00;    /* M֎~ SCIM荞݋֎~ SCK[q͓Clocko */

	return num;
}
#endif /*#ifdef _SPI_DMA **********************************/

void SPI_assertCS() {MMC_CS = 0;}      /* MMC CS = L */
void SPI_negateCS() {MMC_CS = 1;}      /* MMC CS = H */


/** timer service for SD timeout **/

static volatile BYTE DownCounter[2]={0, 0};	/* 100Hz Down Counter */

/* SPI_TimerWork should be called every 10msec from an Interval Timer Interrupt */
void SPI_TimerWork(void)
{
	/*
	static int t=0;
	if (++t&0x40) turnOnLed(1);
	else turnOffLed(1);
	*/
	if (DownCounter[0]) DownCounter[0]--;
	if (DownCounter[1]) DownCounter[1]--;
}

/* Setting initial value to the Down Counter on the centi second time scale */
void SPI_setDownCounter(unsigned char chan, unsigned char csec)
{
	DownCounter[chan]=csec;
}

unsigned char SPI_getDownCounter(unsigned char chan)
{
	return DownCounter[chan];
}
